using System;
using System.Collections.Generic;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;

namespace ExampleMod.Items {
public class ExampleWings : ModItem
{
    public override bool Autoload(ref string name, ref string texture, IList<EquipType> equips)
    {
        equips.Add(EquipType.Wings);
        return true;
    }

    public override void SetDefaults()
    {
        item.name = "Example Wings";
        item.width = 22;
        item.height = 20;
        item.toolTip = "This is a modded wing.";
        item.value = 10000;
        item.rare = 2;
        item.accessory = true;
    }

    //these wings use the same values as the solar wings

    public override void UpdateAccessory(Player player)
    {
        player.wingTimeMax = 180;
    }

    public override void VerticalWingSpeeds(ref float ascentWhenFalling, ref float ascentWhenRising,
       ref float maxCanAscendMultiplier, ref float maxAscentMultiplier, ref float constantAscend)
    {
        ascentWhenFalling = 0.85f;
        ascentWhenRising = 0.15f;
        maxCanAscendMultiplier = 1f;
        maxAscentMultiplier = 3f;
        constantAscend = 0.135f;
    }

    public override void HorizontalWingSpeeds(ref float speed, ref float acceleration)
    {
        speed = 9f;
        acceleration *= 2.5f;
    }

    public override void AddRecipes()
    {
        ModRecipe recipe = new ModRecipe(mod);
        recipe.AddIngredient(null, "EquipMaterial", 60);
        recipe.AddTile(null, "ExampleWorkbench");
        recipe.SetResult(this);
        recipe.AddRecipe();
    }
}}