using System;
using Microsoft.Xna.Framework;
using Terraria;
using Terraria.ModLoader;

namespace ExampleMod.Projectiles {
public class SparklingBall : ModProjectile
{
    public override void SetDefaults()
    {
        projectile.name = "Sparkling Ball";
        projectile.width = 16;
        projectile.height = 16;
        projectile.friendly = true;
        projectile.magic = true;
        projectile.penetrate = 3;
        projectile.timeLeft = 600;
    }

    public override void AI()
    {
        projectile.velocity.Y += projectile.ai[0];
        if(Main.rand.Next(3) == 0)
        {
            ModDust.NewDust(projectile.position + projectile.velocity, projectile.width, projectile.height, mod, "Sparkle", projectile.velocity.X * 0.5f, projectile.velocity.Y * 0.5f);
        }
    }

    public override bool OnTileCollide(Vector2 oldVelocity)
    {
        projectile.penetrate--;
        if(projectile.penetrate <= 0)
        {
            projectile.Kill();
        }
        else
        {
            projectile.ai[0] += 0.1f;
            if(projectile.velocity.X != oldVelocity.X)
            {
                projectile.velocity.X = -oldVelocity.X;
            }
            if(projectile.velocity.Y != oldVelocity.Y)
            {
                projectile.velocity.Y = -oldVelocity.Y;
            }
            projectile.velocity *= 0.75f;
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 10);
        }
        return false;
    }

    public override void Kill(int timeLeft)
    {
        for(int k = 0; k < 5; k++)
        {
            ModDust.NewDust(projectile.position + projectile.velocity, projectile.width, projectile.height, mod, "Sparkle", projectile.oldVelocity.X * 0.5f, projectile.oldVelocity.Y * 0.5f);
        }
        Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 25);
    }

    public override void OnHitNPC(NPC target, int damage, float knockback, bool crit)
    {
        projectile.ai[0] += 0.1f;
        projectile.velocity *= 0.75f;
    }
}}