using System;
using Microsoft.Xna.Framework;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
using Terraria.ObjectData;

namespace ExampleMod.Tiles {
public class ExampleBed : ModTile
{
    public override void SetDefaults()
    {
        Main.tileFrameImportant[Type] = true;
        Main.tileLavaDeath[Type] = true;
        TileObjectData.newTile.CopyFrom(TileObjectData.Style4x2); //this style already takes care of direction for us
        TileObjectData.newTile.CoordinateHeights = new int[]{16, 18};
        TileObjectData.addTile(Type);
        mapColor = new Color(200, 200, 200);
        mapName = "Example Bed";
        adjTiles = new int[]{TileID.Beds};
        bed = true;
    }

    public override void NumDust(int i, int j, bool fail, ref int num)
    {
        num = 1;
    }

    public override bool CreateDust(int i, int j, ref int type)
    {
        ModDust.NewDust(new Vector2(i, j) * 16f, 16, 16, mod, "Sparkle");
        return false;
    }

    public override void KillMultiTile(int i, int j, int frameX, int frameY)
    {
        Item.NewItem(i * 16, j * 16, 64, 32, mod.ItemType("ExampleBed"));
    }

    public override void RightClick(int i, int j)
    {
        Player player = Main.player[Main.myPlayer];
        Tile tile = Main.tile[i, j];
        int spawnX = i - tile.frameX / 18;
        int spawnY = j + 2;
        spawnX += tile.frameX >= 72 ? 5 : 2;
        if(tile.frameY % 38 != 0)
        {
            spawnY--;
        }
        player.FindSpawn();
        if(player.SpawnX == spawnX && player.SpawnY == spawnY)
        {
            player.RemoveSpawn();
            Main.NewText("Spawn point removed!", 255, 240, 20, false);
        }
        else if(Player.CheckSpawn(spawnX, spawnY))
        {
            player.ChangeSpawn(spawnX, spawnY);
            Main.NewText("Spawn point set!", 255, 240, 20, false);
        }
    }

    public override void MouseOver(int i, int j)
    {
        Player player = Main.player[Main.myPlayer];
        player.noThrow = 2;
        player.showItemIcon = true;
        player.showItemIcon2 = mod.ItemType("ExampleBed");
    }
}}